require 'modshogun'

f_feats_train = modshogun.CSVFile("../../data/classifier_4class_2d_linear_features_train.dat")
f_feats_test = modshogun.CSVFile("../../data/classifier_4class_2d_linear_features_test.dat")
f_labels_train = modshogun.CSVFile("../../data/classifier_4class_2d_linear_labels_train.dat")
f_labels_test = modshogun.CSVFile("../../data/classifier_4class_2d_linear_labels_test.dat")
Math:init_random(1)

--![create_features]
features_train = modshogun.RealFeatures(f_feats_train)
features_test = modshogun.RealFeatures(f_feats_test)
labels_train = modshogun.MulticlassLabels(f_labels_train)
labels_test = modshogun.MulticlassLabels(f_labels_test)
--![create_features]

--![set_attribute_types]
ft = modshogun.BoolVector(2)
ft[1] = False
ft[2] = False
--![set_attribute_types]

--![create_instance]
classifier = modshogun.CARTree(ft, modshogun.PT_MULTICLASS, 5, True)
classifier:set_labels(labels_train)
--![create_instance]

--![train_and_apply]
classifier:train(features_train)
labels_predict = classifier:apply_multiclass(features_test)
--![train_and_apply]

--![evaluate_accuracy]
eval = modshogun.MulticlassAccuracy()
accuracy = eval:evaluate(labels_predict, labels_test)
--![evaluate_accuracy]

-- integration testing variables
output = labels_predict:get_labels()

-- Serialize output for integration testing (automatically generated)
__sg_storage = modshogun.WrappedObjectArray()
__sg_storage_file = modshogun.SerializableAsciiFile("cartree.dat", 'w')
__sg_storage:append_wrapped_real(accuracy, "accuracy")
__sg_storage:append_wrapped_real_vector(output, "output")
__sg_storage:save_serializable(__sg_storage_file)
